﻿-- Author      : Nogarder
-- Create Date : 2012/3/8 0:26:40

local getglobal=getglobal
local table_insert=table.insert
local table_remove=table.remove
local table_getn=table.getn
local pairs=pairs

local NPA_ClickZone={}
local FrameList=NPA_Core:RequestFrameList()
local FrameSeted={}
local framecount=0

local NPA_ClickZone_DefaultSettings={
		["ClickZone_Enable"]=0,
		["ClickZone_Show"]=1,
		["ClickZone_Data"]={
			OffsetX=0,
			OffsetY=0,
			Height=36,
			Width=130,
			Red=0,
			Green=0,
			Blue=0,
			Alpha=0.3,
			Texture="Interface\\Addons\\NPA\\Texture\\mono\\bar",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,	
			RAngle=0,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
	}

local NPA_ClickZone_Config=NPA_ClickZone_DefaultSettings
local NPA_ClickZone_Frame={}
local Frame_Width=130
local Frame_Height=36

function NPA_ClickZone:ResetConfig()
	NPA_Config["ClickZone"]=CopyTable(NPA_ClickZone_DefaultSettings)
end


local ClickZone_MainFrame=CreateFrame("Frame","NPA_ClickZone_MainFrame",UIParent)
ClickZone_MainFrame:SetScript("OnUpdate",function()
	if(not UnitAffectingCombat("player"))then
			for _,frame in pairs(FrameList) do
					frame:SetWidth(Frame_Width)
					frame:SetHeight(Frame_Height)
			end
	end

	end)

local ManageTexture=NPA_Core.TextureManager2

local function NPA_ClickZone_SetFrame(iconframe)
	ManageTexture(nil,iconframe.Icon,NPA_ClickZone_Config["ClickZone_Data"],iconframe)
	iconframe.Icon:ClearAllPoints()
	iconframe.Icon:SetPoint("TOPLEFT",iconframe.Parent,"TOPLEFT",0,0)
	iconframe.Icon:SetPoint("BOTTOMRIGHT",iconframe.Parent,"BOTTOMRIGHT")

	if(NPA_ClickZone_Config["ClickZone_Show"]==1)then
		iconframe.Icon:Show()
	else
		iconframe.Icon:Hide()
	end
end

local function NPA_ClickZone_OnUpdate(_,self)
	self:Show()
end

local function NPA_ClickZone_HookFrame(frame)
	if(frame.Parent.IsTracker)then
		return
	end

	local iconframe=CreateFrame("Frame","NPA_ClickZone_Main",frame:GetParent())
	iconframe:SetHeight(1)
	iconframe:SetWidth(1)
	iconframe:SetPoint("CENTER",frame,"CENTER",0,0)
	iconframe.Parent=frame.Parent

	local icon=iconframe:CreateTexture("NPA_ClickZone_Icon","BACKGROUND",nil)

	iconframe.Icon=icon

	table_insert(NPA_ClickZone_Frame,iconframe)

	NPA_ClickZone_SetFrame(iconframe)

	frame["ClickZone"]=iconframe

end

function NPA_ClickZone:ApplyConfig()
	NPA_Core:CheckConfigEntry("ClickZone",NPA_ClickZone_DefaultSettings)

	NPA_ClickZone_Config=NPA_Config["ClickZone"]

	NPA_ClickZone_Config["ClickZone_Data"].Anchor="CENTER"
	NPA_ClickZone_Config["ClickZone_Data"].ToAnchor="CENTER"

	if(NPA_ClickZone_Config["ClickZone_Enable"]==1)then
		Frame_Width=NPA_ClickZone_Config["ClickZone_Data"].Width or 130
		Frame_Height=NPA_ClickZone_Config["ClickZone_Data"].Height or 36
	else
		NPA_ClickZone_Config["ClickZone_Data"].Width=130
		NPA_ClickZone_Config["ClickZone_Data"].Height=36
	end

	if(NPA_Config["Core"]["EnableModule"]["ClickZone"]==1 and NPA_ClickZone_Config["ClickZone_Enable"]==1)then
		ClickZone_MainFrame:Show()
	else
		ClickZone_MainFrame:Hide()
	end

	for _,iconframe in pairs(NPA_ClickZone_Frame) do
		NPA_ClickZone_SetFrame(iconframe)
	end
end


NPA_Core:AddModule("ClickZone",NPA_ClickZone)
NPA_Core:AddHook("ClickZone",NPA_ClickZone_HookFrame)

NPA_Core:HookUpdate("ClickZone",NPA_ClickZone_OnUpdate,1)