﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

local GetTime=GetTime

local NPA_TargetCount={}
--config
local NPA_TargetCount_DefaultSetting={
		["TargetCount_ShowHostile"]=1,
		["TargetCount_ShowNonHostile"]=1,
		
		["TargetCount_OnlyPlayer"]=0,

		["TargetCount_ShowIcon"]=0,
		["TargetCount_FriendlyMax"]=3,
		["TargetCount_HostileMax"]=3,

		["TargetCount_TextData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=-50,
			OffsetY=-40,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["TargetCount_HostileIconData"]={
			OffsetX=-20,
			OffsetY=40,
			Height=30,
			Width=30,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\TargetingFrame\\UI-RaidTargetingIcons",
			TextureBlend="BLEND",
			Left=0.75,
			Right=1,
			Top=0.25,
			Bottom=0.5,
			RAngle=0,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
		["TargetCount_FriendlyIconData"]={
			OffsetX=20,
			OffsetY=40,
			Height=30,
			Width=30,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\TargetingFrame\\UI-RaidTargetingIcons",
			TextureBlend="BLEND",
			Left=0.75,
			Right=1,
			Top=0,
			Bottom=0.25,
			RAngle=0,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
	}
local NPA_TargetCount_Config=NPA_TargetCount_DefaultSetting

function NPA_TargetCount:ResetConfig()
	NPA_Config["TargetCount"]=CopyTable(NPA_TargetCount_DefaultSetting)
end


--global function
local NPA_TargetCount_Frame={}
local table_insert=table.insert

local GetTargetCount=NPA_Core.GetTargetCount

local function NPA_TargetCount_OnUpdate(nTime,self,guid,unitdata,_,_,_,_,_,_,recentUpdated)
	local targetcount=GetTargetCount(guid)
	if(targetcount)then
		local count={[1]=0,[2]=0,[3]=0,[4]=0}
		for i=1,4 do
			for nguid,ntime in pairs(targetcount[i]) do
				if(nTime-ntime<0.5)then
					count[i]=count[i]+1
				end
			end
		end

		local text=""
		local show=0
		local hostilecount
		local friendlycount
		if(NPA_TargetCount_Config["TargetCount_OnlyPlayer"]==1)then
			hostilecount=count[2]
			friendlycount=count[1]
		else
			hostilecount=count[2]+count[4]
			friendlycount=count[1]+count[3]
		end

		if(NPA_TargetCount_Config["TargetCount_ShowNonHostile"]==1 and friendlycount>0)then
			text=text.."|cff00ff00["..friendlycount.."]"
		end
		if(NPA_TargetCount_Config["TargetCount_ShowHostile"]==1 and hostilecount>0)then
			text=text.."|cffff0000["..hostilecount.."]"
		end
		if(text~="")then
			self.Text:SetText(text)
			self.Text:Show()
		else
			self.Text:Hide()
		end
	
		if(NPA_TargetCount_Config["TargetCount_ShowIcon"]==1)then
			if(friendlycount>NPA_TargetCount_Config["TargetCount_FriendlyMax"])then
				self.FriendlyIcon:Show()
			else
				self.FriendlyIcon:Hide()
			end
			
			if(hostilecount>NPA_TargetCount_Config["TargetCount_HostileMax"])then
				self.HostileIcon:Show()
			else
				self.HostileIcon:Hide()
			end
			self.IconMainFrame:Show()
		end

		self:Show()
	else
		self:Hide()
	end
end
local ManageFont=NPA_Core.FontManager
local ManageTexture=NPA_Core.TextureManager2


local function NPA_TargetCount_SetText(mainframe)
	local text=mainframe.Text

	ManageFont(nil,text,NPA_TargetCount_Config["TargetCount_TextData"],mainframe)

	text:Show()

	ManageTexture(nil,mainframe.HostileIcon,NPA_TargetCount_Config["TargetCount_HostileIconData"],mainframe.IconMainFrame)
	ManageTexture(nil,mainframe.FriendlyIcon,NPA_TargetCount_Config["TargetCount_FriendlyIconData"],mainframe.IconMainFrame)

	mainframe.HostileIcon:Hide()
	mainframe.FriendlyIcon:Hide()

	if(NPA_TargetCount_Config["TargetCount_ShowIcon"]==1)then
		mainframe.IconMainFrame:Show()
	else
		mainframe.IconMainFrame:Hide()
	end
end

local function NPA_TargetCount_HookFrame(frame)
	local mainframe=CreateFrame("Frame","NPA_TargetCount_MainFrame",frame)
	mainframe:SetHeight(1)
	mainframe:SetWidth(1)
	mainframe:SetPoint("CENTER",frame,"CENTER",0,0)
	--mainframe:SetFrameStrata("LOW")
	mainframe:Hide()

	local text=mainframe:CreateFontString("NPA_TargetCount_Text","OVERLAY")
	text:SetTextColor(1,1,0,1)
	text:Hide()

	mainframe.Text=text

	local iconmainframe=CreateFrame("Frame","NPA_TargetCount_MainFrame",frame:GetParent())
	iconmainframe:SetHeight(1)
	iconmainframe:SetWidth(1)
	iconmainframe:SetPoint("CENTER",frame,"CENTER",0,0)
	iconmainframe:Hide()

	mainframe:HookScript("OnHide",function(self)
		self.IconMainFrame:Hide()
		end)


	local hostileicon=iconmainframe:CreateTexture("NPA_TargetCount_HostileIcon","OVERLAY",nil)
	hostileicon:Show()

	local friendlyicon=iconmainframe:CreateTexture("NPA_TargetCount_FriendlyIcon","OVERLAY",nil)
	friendlyicon:Show()

	mainframe.HostileIcon=hostileicon
	mainframe.FriendlyIcon=friendlyicon
	mainframe.IconMainFrame=iconmainframe

	NPA_TargetCount_SetText(mainframe)
	table_insert(NPA_TargetCount_Frame,mainframe)

	frame["TargetCount"]=mainframe

end

function NPA_TargetCount:ApplyConfig()
	NPA_Core:CheckConfigEntry("TargetCount",NPA_TargetCount_DefaultSetting)

	NPA_TargetCount_Config=NPA_Config["TargetCount"]

	for _,mainframe in pairs(NPA_TargetCount_Frame) do
		NPA_TargetCount_SetText(mainframe)
	end

end

function NPA_TargetCount:RequireDataCollet()
	NPA_Core.Data_Filter["TargetCount"]=1
end



NPA_Core:AddHook("TargetCount",NPA_TargetCount_HookFrame)
NPA_Core:AddModule("TargetCount",NPA_TargetCount)
NPA_Core:HookUpdate("TargetCount",NPA_TargetCount_OnUpdate,2)