﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11
if(NPA_Core:CheckHook("CastWarning"))then


local Localization={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs

local Tooltips={}

if(locale=="zhTW")then
	Localization={
		["PageName"]="施法警告",
		["ShowName"]="顯示法術名",
		["OnlyPlayer"]="只顯示玩家",
		["ShowText"]="顯示時間",
		["ShowMax"]="顯示最大時間",
		["HideTotem"]="隱藏圖騰",
		["Bar"]="條",
		["Border"]="邊框",
		["Background"]="背景",
		["Icon"]="圖標",
		["Text"]="文本",
		["Value"]="當前時間",
		["Max"]="最大時間",
		["IconBackground"]="圖標背景",
		["BarShield"]="條防打斷盾牌",
		["IconShield"]="圖標防打斷盾",
		["AlwaysShowShield"]="總是顯示防打斷盾",
		["IconOverlay"]="圖標前景",

		["OffsetX"]="X偏移",
		["OffsetY"]="Y偏移",

		["ColorBySchool"]="按法術系別著色",
		["ReversTime"]="反轉時間顯示",
		["ColorByTime"]="按時間著色",

		["InstantDontShowBar"]="瞬發法術不顯示條",
		["ShowBar"]="顯示施法條",
		["ShowIcon"]="顯示圖標",

		["ThresholdBar"]="閥值條",
		["ThresholdAlways"]="總是顯示閥值條",
		["ThresholdPercent"]="閥值按百分比",
		["Threshold"]="閥值",
	}
	Tooltips={
		["CastWarning"]="顯示施法時間,圖標,法術名稱和計時條",
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="施法警告",
		["ShowName"]="显示法术名",
		["OnlyPlayer"]="只显示玩家",
		["ShowText"]="显示时间",
		["ShowMax"]="显示最大时间",
		["HideTotem"]="隐藏图腾",
		["Bar"]="条",
		["Border"]="边框",
		["Background"]="背景",
		["Icon"]="图标",
		["Text"]="文本",
		["Value"]="当前时间",
		["Max"]="最大时间",
		["IconBackground"]="图标背景",
		["BarShield"]="条防打断盾",
		["IconShield"]="图标防打断盾",
		["AlwaysShowShield"]="总是显示防打断盾",
		["IconOverlay"]="图标前景",
		["OffsetX"]="X偏移",
		["OffsetY"]="Y偏移",

		["ColorBySchool"]="按法术系别着色",
		["ReversTime"]="反转时间显示",
		["ColorByTime"]="按时间着色",
		["InstantDontShowBar"]="顺发法术不显示条",
		["ShowBar"]="显示施法条",
		["ShowIcon"]="显示图标",

		["ThresholdBar"]="阀值条",
		["ThresholdAlways"]="总是显示阀值条",
		["ThresholdPercent"]="阀值按百分比",
		["Threshold"]="阀值",

	}
	Tooltips={
		["CastWarning"]="显示施法时间,图标,法术名称和计时条",
	}
else
	Localization={
		["PageName"]="CastWarning",
		["ShowName"]="Show spell name",
		["OnlyPlayer"]="Show only player",
		["ShowText"]="Show time",
		["ShowMax"]="Show max time",
		["HideTotem"]="Hide totem",
		["Bar"]="Bar",
		["Border"]="Border",
		["Background"]="Background",
		["Icon"]="Icon",
		["Text"]="Text",
		["Value"]="Value",
		["Max"]="Max",
		["IconBackground"]="Icon background",
		["BarShield"]="Bar interrupt shield",
		["IconShield"]="Icon interrupt shield",
		["AlwaysShowShield"]="Always show interrupt shield",
		["IconOverlay"]="Icon overlay",

		["OffsetX"]="Offset X",
		["OffsetY"]="Offset Y",

		["ColorBySchool"]="Color by spell school",
		["AlterInstant"]="Show instant as 1s casting",

		["ReversTime"]="Reverse time display",
		["ColorByTime"]="Color by time",

		["InstantDontShowBar"]="Don't show bar for instant spell",
		["ShowBar"]="Show castbar",
		["ShowIcon"]="Show icon",

		["ThresholdBar"]="Threshold bar",
		["ThresholdAlways"]="Always show threshold bar",
		["ThresholdPercent"]="Threshold uses percent",
		["Threshold"]="Threshold",
	}
	Tooltips={
		["CastWarning"]="Shows casting timer,icon,spell name and timer bar",
	}
end


local mainframe=NPA_Options:AddPage("NPA_Options_CastWaring",Localization["PageName"],"CastWarning",Tooltips["CastWarning"])

local Options=mainframe.Options

----------------
local sliderlist={
	["CastWarning_OffsetX"]={
		Name=Localization["OffsetX"],
		Min=-150,
		Max=150,
		Step=1,
		Width=140,
		OffsetX=20,
		OffsetY=-5
	},
	["CastWarning_OffsetY"]={
		Name=Localization["OffsetY"],
		Min=-150,
		Max=150,
		Step=1,
		Width=140,
		OffsetX=190,
		OffsetY=-5
	},
	["CastWarning_Threshold"]={
		Name=Localization["Threshold"],
		Min=0,
		Max=5,
		Step=0.1,
		Width=280,
		OffsetX=20,
		OffsetY=-45
	}
}

NPA_Options:BuildSliderList("NPA_Options_CastWarning",mainframe,sliderlist,Options)

NPA_Options:CreateSliderEditButton(Localization["Bar"],mainframe,"CastWarning_BarData",1,Options,3)
NPA_Options:CreateSliderEditButton(Localization["Border"],mainframe,"CastWarning_BorderData",1,Options,4)
NPA_Options:CreateSliderEditButton(Localization["Background"],mainframe,"CastWarning_BackgroundData",1,Options,5)
NPA_Options:CreateSliderEditButton(Localization["BarShield"],mainframe,"CastWarning_BarShieldData",1,Options,6)
NPA_Options:CreateSliderEditButton(Localization["ThresholdBar"],mainframe,"CastWarning_ThresholdData",1,Options,7)

NPA_Options:CreateSliderEditButton(Localization["Icon"],mainframe,"CastWarning_IconData",3,Options,8.5)
NPA_Options:CreateSliderEditButton(Localization["IconBackground"],mainframe,"CastWarning_IconBackgroundData",3,Options,9.5)
NPA_Options:CreateSliderEditButton(Localization["IconOverlay"],mainframe,"CastWarning_IconOverlayData",3,Options,10.5)
NPA_Options:CreateSliderEditButton(Localization["IconShield"],mainframe,"CastWarning_IconShieldData",3,Options,11.5)

NPA_Options:CreateSliderEditButton(Localization["Text"],mainframe,"CastWarning_TextData",2,Options,13)
NPA_Options:CreateSliderEditButton(Localization["Value"],mainframe,"CastWarning_ValueData",2,Options,14)
NPA_Options:CreateSliderEditButton(Localization["Max"],mainframe,"CastWarning_MaxData",2,Options,15)
----------------------
local listframe=NPA_Options:CreateFrame("NPA_Options_CastWarning_Filter",mainframe)
listframe:SetPoint("TOPRIGHT",-6,-6)
listframe:SetHeight(360)
listframe:SetWidth(200)

local checkboxdata={
	["CastWarning_ShowName"]=Localization["ShowName"],
	["CastWarning_ShowText"]=Localization["ShowText"],
	["CastWarning_ShowMax"]=Localization["ShowMax"],
	["CastWarning_ShowBar"]=Localization["ShowBar"],
	["CastWarning_ShowIcon"]=Localization["ShowIcon"],
	["CastWarning_AlwaysShowShield"]=Localization["AlwaysShowShield"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_CastWarning",listframe,21,checkboxdata,17,Options,1)

local listframe2=NPA_Options:CreateFrame("NPA_Options_CastWarning_Filter2",mainframe)
listframe2:SetPoint("TOPLEFT",listframe,"BOTTOMLEFT",0,-6)
listframe2:SetPoint("TOPRIGHT",listframe,"BOTTOMRIGHT",0,-6)

local checkboxdata={
	["CastWarning_InstantDontShowBar"]=Localization["InstantDontShowBar"],
	["CastWarning_OnlyPlayer"]=Localization["OnlyPlayer"],
	["CastWarning_HideTotem"]=Localization["HideTotem"],
	["CastWarning_ColorBySchool"]=Localization["ColorBySchool"],
	["CastWarning_ReversTime"]=Localization["ReversTime"],
	["CastWarning_ColorByTime"]=Localization["ColorByTime"]
}

NPA_Options:BuildCheckBoxList("NPA_Options_CastWarning2",listframe2,21,checkboxdata,17,Options,1)


local listframe3=NPA_Options:CreateFrame("NPA_Options_CastWarning_Filter3",mainframe)
listframe3:SetPoint("TOPLEFT",listframe2,"BOTTOMLEFT",0,-6)
listframe3:SetPoint("TOPRIGHT",listframe2,"BOTTOMRIGHT",0,-6)

local checkboxdata={
	["CastWarning_ThresholdPercent"]=Localization["ThresholdPercent"],
	["CastWarning_ThresholdAlways"]=Localization["ThresholdAlways"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_CastWarning2",listframe3,21,checkboxdata,17,Options,1)


end