﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

if(NPA_Core:CheckHook("NameText"))then


local Localization={}
local Tooltips={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs

if(locale=="zhTW")then
	Localization={
		["PageName"]="姓名文本",
		["NameByFaction"]="用陣營著色姓名",
		["BoldHostileName"]="不淡化敵對",
		["BoldNonHostileName"]="不淡化友方",
		["BoldNeutralName"]="不淡化中立",
		["NameByClass"]="用職業著色姓名",
		["ShowGuild"]="顯示工會名",
		["ShowNPCGuild"]="顯示NPC工會名",
		["HideWithHealthBar"]="血條淡化時也淡化",
		["ShowMark"]="啟用標記",
		["MarkTarget"]="標記我的目標",
		["MarkGuildMember"]="標記工會成員",
		["MarkFriend"]="標記我的好友",
		["MarkRaidMember"]="標記團隊成員",
		["MarkPartyMember"]="標記小隊成員",
		["MarkHideInInstance"]="副本中隱藏標記",
		["MarkColorByType"]="標記按類型上色",
		["ShowName"]="顯示姓名",
		["HideTotemName"]="隱藏圖騰名",
		["HideGuildInInstance"]="副本中隱藏工會",
		["MarkPartyAsRaid"]="在團隊中時將小隊標記為團隊",
		["Name"]="姓名",
		["Guild"]="工會",
		["NPCGuild"]="NPC工會",
		["Mark"]="標記",
		["FullName"]="顯示軍銜和頭銜",
		["ShowHostilePortrait"]="顯示敵對目標頭像",
		["ShowNonHostilePortrait"]="顯示非敵對目標頭像",
		["ShowPartyPortrait"]="顯示小隊成員頭像",
		["ShowGuildPortrait"]="顯示工會成員頭像",
		["ShowRaidPortrait"]="顯示團隊成員頭像",
		["ShowTargetPortrait"]="顯示目標頭像",
		["ShowFocusPortrait"]="顯示Focus頭像",
		["ShowMouseoverPortrait"]="顯示鼠標劃過頭像",

		["Portrait"]="頭像",
		["ShowPortrait"]="啟用頭像",
		["ShowOnlyPlayerPortrait"]="只顯示玩家頭像",
		["AutoHideGuild"]="姓名板不淡化時隱藏工會",
		["ColorTarget"]="著色目標名稱",
		["ColorFocus"]="著色focus名稱",
		["ColorMouseover"]="著色鼠標滑過名稱",
		["MarkFocus"]="標記focus",
		["MarkMouseover"]="標記鼠标滑过",
		["Border"]="邊框",
		["Background"]="背景",
		["ShowBorder"]="顯示邊框",
		["ShowBackground"]="顯示背景",
		["ShowPVPFlag"]="顯示PvP標記",
		["PVPFlag"]="PvP標記",

		["SeparateNameText"]="使用分離的姓名文本設置",
		["HostilePlayer"]="敵對玩家",
		["FriendlyPlayer"]="友方玩家",
		["NeutralPlayer"]="中立玩家",
		["FriendlyNonPlayer"]="友方非玩家",
		["HostileNonPlayer"]="敵對非玩家",
		["NeutralNonPlayer"]="中立非玩家",
		["PvPHostile"]="關閉PVP的敵對非玩家",
		["PvPNeutral"]="關閉PVP的中立玩家",
		["PvPFriendly"]="關閉PVP的友方玩家",
		["TappedMob"]="被搶先的怪物",

		["TextColor"]="姓名著色設置",

		["QuestUnitName"]="任務單位姓名",
		["TargetName"]="目標姓名",
		["FocusName"]="Focus姓名",
		["MouseoverName"]="鼠標滑過姓名",

		["LimitLength"]="限制姓名長度",
		["Length"]="最大姓名長度",

		["NameByDefault"]="按默認顏色著色姓名",

		["MainList"]="主要",
		["ShowList"]="顯示",
		["ColorList"]="著色",
		["FilterList"]="過濾",
		["PortraitList"]="頭像",
		["MarkList"]="標記",

		["CustomTextOrderList"]="自定義姓名文本順序"
	}
	ColorLocalization={
		[0]="按默認",
		[1]="按照陣營",
		[2]="按照職業",
		[3]="不修改",
	}
	ColorLocalization2={
		[0]="按默認",
		[1]="按照陣營",
		[3]="不修改",
	}

	Tooltips={
		["NameText"]="顯示單位的姓名,工會,頭像,以及目標/鼠標滑過/focus的特殊標記"
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="姓名文本",
		["NameByFaction"]="用阵营着色姓名",
		["BoldHostileName"]="不淡化敌对",
		["BoldNonHostileName"]="不淡化友方",
		["BoldNeutralName"]="不淡化中立",
		["NameByClass"]="用职业着色姓名",
		["ShowGuild"]="显示工会名",
		["ShowNPCGuild"]="显示NPC工会名",
		["HideWithHealthBar"]="当血条淡化时淡化",
		["ShowMark"]="启用标记",
		["MarkTarget"]="标记我的目标",
		["MarkGuildMember"]="标记工会成员",
		["MarkFriend"]="标记我的好友",
		["MarkRaidMember"]="标记团队成员",
		["MarkPartyMember"]="标记小队成员",
		["MarkHideInInstance"]="副本中隐藏标记",
		["MarkColorByType"]="标记按类型上色",
		["ShowName"]="显示姓名",
		["HideTotemName"]="隐藏图腾名",
		["HideGuildInInstance"]="副本中隐藏工会",
		["MarkPartyAsRaid"]="在团队中时将小队标记为团队",
		["Name"]="姓名",
		["Guild"]="工会",
		["NPCGuild"]="NPC工会",
		["Mark"]="标记",
		["FullName"]="显示军衔和头衔",
		["ShowHostilePortrait"]="显示敌对目标头像",
		["ShowNonHostilePortrait"]="显示其它非敌对目标头像",
		["ShowPartyPortrait"]="显示小队成员头像",
		["ShowGuildPortrait"]="显示工会成员头像",
		["ShowRaidPortrait"]="显示团队成员头像",
		["ShowTargetPortrait"]="显示目标头像",
		["ShowFocusPortrait"]="显示Focus头像",
		["ShowMouseoverPortrait"]="显示鼠标划过头像",

		["Portrait"]="头像",
		["ShowPortrait"]="启用头像",
		["ShowOnlyPlayerPortrait"]="只显示玩家头像",
		["AutoHideGuild"]="姓名板不淡化时隐藏工会",
		["ColorTarget"]="着色目标名称",
		["ColorFocus"]="着色focus名称",
		["ColorMouseover"]="着色鼠标滑过名称",
		["MarkFocus"]="标记focus",
		["MarkMouseover"]="标记鼠标滑过",
		["Border"]="边框",
		["Background"]="背景",
		["ShowBorder"]="显示边框",
		["ShowBackground"]="显示背景",
		["ShowPVPFlag"]="显示PvP标记",
		["PVPFlag"]="PvP标记",

		["SeparateNameText"] ="使用分离的姓名文本设定",
		["HostilePlayer"] ="敌对玩家",
		["FriendlyPlayer"] ="友方玩家",
		["NeutralPlayer"] ="中立玩家",
		["FriendlyNonPlayer"] ="友方非玩家",
		["HostileNonPlayer"] ="敌对非玩家",
		["NeutralNonPlayer"] ="中立非玩家",
		["PvPHostile"] ="关闭PVP的敌对玩家",
		["PvPNeutral"] ="关闭PVP的中立玩家",
		["PvPFriendly"] ="关闭PVP的友方玩家",
		["TappedMob"] ="被抢先的怪物",


		["TextColor"]="姓名着色设置",

		["QuestUnitName"]="任务单位姓名",
		["TargetName"]="目标姓名",
		["FocusName"]="Focus姓名",
		["MouseoverName"]="鼠标滑过姓名",

		["LimitLength"]="限制姓名长度",
		["Length"]="最大姓名长度",

		["NameByDefault"]="按默认颜色着色姓名",

		["MainList"]="主要",
		["ShowList"]="显示",
		["ColorList"]="着色",
		["FilterList"]="过滤",
		["PortraitList"]="头像",
		["MarkList"]="标记",

		["CustomTextOrderList"]="自定义姓名文本順序"
	}
	ColorLocalization={
		[0]="按默认",
		[1]="按照阵营",
		[2]="按照职业",
		[3]="不修改",
	}
	ColorLocalization2={
		[0]="按默认",
		[1]="按照阵营",
		[3]="不修改",
	}

	Tooltips={
		["NameText"]="显示单位的姓名,工会,头像,以及目标/鼠标滑过/focus的特殊标记"
	}
else
	Localization={
		["PageName"]="NameText",
		["NameByFaction"]="Color name by faction",
		["BoldHostileName"]="Don't fade hostile",
		["BoldNonHostileName"]="Don't fade friendly",
		["BoldNeutralName"]="Don't fade neutral",
		["NameByClass"]="Color name by class",
		["ShowGuild"]="Show guild",
		["ShowNPCGuild"]="Show NPC guild",
		["HideWithHealthBar"]="Fade with healthbar",
		["ShowMark"]="Enable mark",
		["MarkTarget"]="Mark my target",
		["MarkGuildMember"]="Mark guild member",
		["MarkFriend"]="Mark my friend",
		["MarkRaidMember"]="Mark raid member",
		["MarkPartyMember"]="Mark party member",
		["MarkHideInInstance"]="Hide mark in instance",
		["MarkColorByType"]="Color mark by type",
		["ShowName"]="Show name",
		["HideTotemName"]="Hide totem name",
		["HideGuildInInstance"]="Hide guild in instance",
		["MarkPartyAsRaid"]="Mark party as raid if in raid",
		["Name"]="Name",
		["Guild"]="Guild",
		["NPCGuild"]="NPC Guild",
		["Mark"]="Mark",
		["FullName"]="Show rank and title",
		["ShowHostilePortrait"]="Show hostile portrait",
		["ShowNonHostilePortrait"]="Show other non-hostile portrait",
		["ShowPartyPortrait"]="Show party member portrait",
		["ShowGuildPortrait"]="Show guild member portrait",
		["ShowRaidPortrait"]="Show raid member portrait",
		["ShowTargetPortrait"]="Show target portrait",
		["ShowFocusPortrait"]="Show focus portrait",
		["ShowMouseoverPortrait"]="Show mouseover portrait",

		["Portrait"]="Portrait",
		["ShowPortrait"]="Enable portrait",
		["ShowOnlyPlayerPortrait"]="Show only player portrait",
		["AutoHideGuild"]="Hide guild when nameplate not fading",
		["ColorTarget"]="Color target name",
		["ColorFocus"]="Color focus name",
		["ColorMouseover"]="Color mouseover name",
		["MarkFocus"]="Mark focus",
		["MarkMouseover"]="Mark mouseover",
		["Border"]="Border",
		["Background"]="Background",
		["ShowBorder"]="Show border",
		["ShowBackground"]="Show background",
		["ShowPVPFlag"]="Show PvP flag",
		["PVPFlag"]="PvP flag",

		["SeparateNameText"] ="Separate nametext settings",
		["HostilePlayer"] ="Hostile player",
		["FriendlyPlayer"] ="Friendly player",
		["NeutralPlayer"] ="Neutral player",
		["FriendlyNonPlayer"] ="Friendly non-player",
		["HostileNonPlayer"] ="Hostile non-player",
		["NeutralNonPlayer"] ="Neutral non-player",
		["PvPHostile"] ="Hostile player with pvp off",
		["PvPNeutral"] ="Neutral player with pvp off",
		["PvPFriendly"] ="Friendly player with pvp off",
		["TappedMob"] ="Tapped mob",

		["TextColor"]="Text coloring",

		["QuestUnitName"]="Quest unit name",
		["TargetName"]="Target name",
		["FocusName"]="Focus name",
		["MouseoverName"]="Mouseover name",
		["LimitLength"]="Limit name length",
		["Length"]="Max name length",
		
		["NameByDefault"]="Color name by default",

		["MainList"]="Main",
		["ShowList"]="Show",
		["ColorList"]="Coloring",
		["FilterList"]="Filters",
		["PortraitList"]="Portrait",
		["MarkList"]="Mark",

		["CustomTextOrderList"]="Custom nametext order"

	}

	ColorLocalization={
		[0]="By default",
		[1]="By faction",
		[2]="By class",
		[3]="Dont' change",
	}
	ColorLocalization2={
		[0]="By default",
		[1]="With faction",
		[3]="Dont' change",
	}

	Tooltips={
		["NameText"]="Show name,guild,portrait for unit, and special mark for target/mouseover/focus"
	}

end


local mainframe=NPA_Options:AddPage("NPA_Options_NameText",Localization["PageName"],"NameText",Tooltips["NameText"])

local Options=mainframe.Options


NPA_Options:CreateSliderEditButton(Localization["Name"],mainframe,"NameText_TextData",2,Options,1)
NPA_Options:CreateSliderEditButton(Localization["Guild"],mainframe,"NameText_GuildData",2,Options,2)
NPA_Options:CreateSliderEditButton(Localization["NPCGuild"],mainframe,"NameText_NPCGuildData",2,Options,3.5)
NPA_Options:CreateSliderEditButton(Localization["Mark"],mainframe,"NameText_MarkData",3,Options,5)

NPA_Options:CreateSliderEditButton(Localization["Portrait"],mainframe,"NameText_PortraitData",3,Options,1,1)
NPA_Options:CreateSliderEditButton(Localization["Border"],mainframe,"NameText_BorderData",1,Options,2.5,1)
NPA_Options:CreateSliderEditButton(Localization["Background"],mainframe,"NameText_BackgroundData",1,Options,3.5,1)
NPA_Options:CreateSliderEditButton(Localization["PVPFlag"],mainframe,"NameText_PVPFlagData",3,Options,5,1)


--------------
local checkbox=NPA_Options:CreateCheckBox("NPA_Options_NameText_SeparateNameText",mainframe,21,Localization["SeparateNameText"],"NameText_SeparateNameText")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-420)
table_insert(Options,checkbox)

local textframe=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",checkbox,Localization["SeparateNameText"])
local button01=NPA_Options:CreateButton("NPA_Options_NameText_SeparateNameTextSetting",mainframe,200,21,Localization["SeparateNameText"])
button01:SetPoint("TOPLEFT",checkbox,"BOTTOMLEFT",0,-3)
button01:SetScript("OnClick",function()
		if(textframe:IsShown())then
			textframe:Hide()
		else
			textframe:Show()
		end
	end)

button01:SetScript("OnShow",function()
	textframe:Show()
	textframe:Hide()
	end)

textframe:SetPoint("BOTTOMRIGHT",mainframe,"BOTTOMRIGHT",0,10)
textframe:SetWidth(370)
textframe:SetHeight(520)
textframe:SetFrameStrata("HIGH")
textframe:Hide()

---------------------------------------------------------------
local buttonframe1=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",textframe)
buttonframe1:SetPoint("TOPRIGHT",textframe,"TOPRIGHT",-3,-3)
buttonframe1:SetPoint("TOPLEFT",textframe,"TOPLEFT",3,-3)
buttonframe1:SetHeight(160)

NPA_Options:CreateSliderEditButton(Localization["HostilePlayer"],buttonframe1,"NameText_TextHostilePlayerData",2,Options,0)
NPA_Options:CreateSliderEditButton(Localization["FriendlyPlayer"],buttonframe1,"NameText_TextFriendlyPlayerData",2,Options,1)
NPA_Options:CreateSliderEditButton(Localization["NeutralPlayer"],buttonframe1,"NameText_TextNeutralPlayerData",2,Options,2)
NPA_Options:CreateSliderEditButton(Localization["HostileNonPlayer"],buttonframe1,"NameText_TextHostileNonPlayerData",2,Options,3)
NPA_Options:CreateSliderEditButton(Localization["FriendlyNonPlayer"],buttonframe1,"NameText_TextFriendlyNonPlayerData",2,Options,4)

NPA_Options:CreateSliderEditButton(Localization["NeutralNonPlayer"],buttonframe1,"NameText_TextNeutralNonPlayerData",2,Options,0,1)
NPA_Options:CreateSliderEditButton(Localization["PvPHostile"],buttonframe1,"NameText_TextPVPHostileData",2,Options,1,1)
NPA_Options:CreateSliderEditButton(Localization["PvPFriendly"],buttonframe1,"NameText_TextPVPFriendlyData",2,Options,2,1)
NPA_Options:CreateSliderEditButton(Localization["PvPNeutral"],buttonframe1,"NameText_TextPVPFriendlyData",2,Options,3,1)
NPA_Options:CreateSliderEditButton(Localization["TappedMob"],buttonframe1,"NameText_TextTappedData",2,Options,4,1)

local orderbutton=NPA_Options:CreateOrderEdit("NPA_Options_NameText_CustomText_Order",textframe,Localization["CustomTextOrderList"],"NameText_CustomTextData",Localization)
orderbutton:SetPoint("TOPLEFT",buttonframe1,"BOTTOMLEFT",0,-25)
orderbutton:SetPoint("BOTTOMRIGHT",textframe,"BOTTOMRIGHT",-3,5)
table_insert(Options,orderbutton)

------------------------------------
local colorframe=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe,Localization["TextColor"])

local button02=NPA_Options:CreateButton("NPA_Options_NameText_CustomBarSetting",mainframe,0,21,Localization["TextColor"])
button02:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-390)
button02:SetScript("OnClick",function()
		if(colorframe:IsShown())then
			colorframe:Hide()
		else
			colorframe:Show()
		end
	end)

colorframe:SetPoint("LEFT",button02,"RIGHT",0,10)
colorframe:SetWidth(280)
colorframe:SetFrameStrata("HIGH")
colorframe:SetHeight(280)
colorframe:Hide()

local dropselect1=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorHostilePlayer",colorframe,220,24,Localization["HostilePlayer"],"NameText_ColorHostilePlayerData",ColorLocalization)
dropselect1:SetPoint("TOPLEFT",colorframe,"TOPLEFT",20,-10)
table_insert(Options,dropselect1)

local dropselect2=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorNeutralPlayer",colorframe,220,24,Localization["NeutralPlayer"],"NameText_ColorNeutralPlayerData",ColorLocalization)
dropselect2:SetPoint("TOPLEFT",dropselect1,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect2)

local dropselect3=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorFriendlyPlayer",colorframe,220,24,Localization["FriendlyPlayer"],"NameText_ColorFriendlyPlayerData",ColorLocalization)
dropselect3:SetPoint("TOPLEFT",dropselect2,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect3)

local dropselect4=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorHostileNonPlayer",colorframe,220,24,Localization["HostileNonPlayer"],"NameText_ColorHostileNonPlayerData",ColorLocalization2)
dropselect4:SetPoint("TOPLEFT",dropselect3,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect4)

local dropselect5=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorNeutralNonPlayer",colorframe,220,24,Localization["NeutralNonPlayer"],"NameText_ColorNeutralNonPlayerData",ColorLocalization2)
dropselect5:SetPoint("TOPLEFT",dropselect4,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect5)

local dropselect6=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorFriendlyNonPlayer",colorframe,220,24,Localization["FriendlyNonPlayer"],"NameText_ColorFriendlyNonPlayerData",ColorLocalization2)
dropselect6:SetPoint("TOPLEFT",dropselect5,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect6)

local dropselect7=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorPvPHostile",colorframe,220,24,Localization["PvPHostile"],"NameText_ColorPvPHostileData",ColorLocalization)
dropselect7:SetPoint("TOPLEFT",dropselect6,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect7)

local dropselect8=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorPvPNeutral",colorframe,220,24,Localization["PvPNeutral"],"NameText_ColorPvPNeutralData",ColorLocalization)
dropselect8:SetPoint("TOPLEFT",dropselect7,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect8)

local dropselect9=NPA_Options:CreateDropDownSelect("NPA_Options_NameText_ColorPvPFriendly",colorframe,220,24,Localization["PvPFriendly"],"NameText_ColorPvPFriendlyData",ColorLocalization)
dropselect9:SetPoint("TOPLEFT",dropselect8,"BOTTOMLEFT",0,-5)
table_insert(Options,dropselect9)


------------------------------------------------------------------
mainframe:HookScript("OnShow",function()
		textframe:Show()
		textframe:Hide()
		colorframe:Show()
		colorframe:Hide()
	end)
-------------------------------------------------------------------


-----------------
local listframe=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe)
local checkboxdata={
	["NameText_BoldHostile"]=Localization["BoldHostileName"],
	["NameText_BoldNonHostile"]=Localization["BoldNonHostileName"],
	["NameText_BoldNeutral"]=Localization["BoldNeutralName"],
	["NameText_FullName"]=Localization["FullName"],
	["NameText_ShowBorder"]=Localization["ShowBorder"],
	["NameText_ShowBackground"]=Localization["ShowBackground"],
	["NameText_HideWithHealthBar"]=Localization["HideWithHealthBar"],
	["NameText_Name"]=Localization["ShowName"],
	["NameText_Guild"]=Localization["ShowGuild"],
	["NameText_NPCGuild"]=Localization["ShowNPCGuild"],
	["NameText_HideTotemName"]=Localization["HideTotemName"],
	["NameText_HideGuildInInstance"]=Localization["HideGuildInInstance"],
	["NameText_AutoHideGuild"]=Localization["AutoHideGuild"],
	["NameText_ShowPVPFlag"]=Localization["ShowPVPFlag"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe,21,checkboxdata,17,Options,1,1)

local listframe3=NPA_Options:CreateFrame("NPA_Options_NameText_Filter3",mainframe)
local checkboxdata={
	["NameText_ColorTarget"]=Localization["ColorTarget"],
	["NameText_ColorFocus"]=Localization["ColorFocus"],
	["NameText_ColorMouseover"]=Localization["ColorMouseover"],
	["NameText_Tapped"]=Localization["TappedMob"],
}
NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe3,21,checkboxdata,17,Options,1,1)

local listframe4=NPA_Options:CreateFrame("NPA_Options_NameText_Filter4",mainframe)
local checkboxdata={
	["NameText_HostilePlayerName"]=Localization["HostilePlayer"],
	["NameText_NeutralPlayerName"]=Localization["NeutralPlayer"],
	["NameText_FriendlyPlayerName"]=Localization["FriendlyPlayer"],
	["NameText_HostileNonPlayerName"]=Localization["HostileNonPlayer"],
	["NameText_NeutralNonPlayerName"]=Localization["NeutralNonPlayer"],
	["NameText_FriendlyNonPlayerName"]=Localization["FriendlyNonPlayer"],
	["NameText_QuestUnitName"]=Localization["QuestUnitName"],
	["NameText_TargetName"]=Localization["TargetName"],
	["NameText_FocusName"]=Localization["FocusName"],
	["NameText_MouseoverName"]=Localization["MouseoverName"],

}
NPA_Options:BuildCheckBoxList("NPA_Options_NameText2",listframe4,21,checkboxdata,17,Options,1,1)


local listframe5=NPA_Options:CreateFrame("NPA_Options_NameText_Filter5",mainframe)
local checkboxdata={
	["NameText_ShowHostilePortrait"]=Localization["ShowHostilePortrait"],
	["NameText_ShowNonHostilePortrait"]=Localization["ShowNonHostilePortrait"],
	["NameText_ShowPartyPortrait"]=Localization["ShowPartyPortrait"],
	["NameText_ShowRaidPortrait"]=Localization["ShowRaidPortrait"],
	["NameText_ShowGuildPortrait"]=Localization["ShowGuildPortrait"],
	["NameText_ShowPortrait"]=Localization["ShowPortrait"],
	["NameText_ShowOnlyPlayerPortrait"]=Localization["ShowOnlyPlayerPortrait"],
	["NameText_ShowTargetPortrait"]=Localization["ShowTargetPortrait"],
	["NameText_ShowFocusPortrait"]=Localization["ShowFocusPortrait"],
	["NameText_ShowMouseoverPortrait"]=Localization["ShowMouseoverPortrait"],

}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe5,21,checkboxdata,17,Options,1,1)

local listframe6=NPA_Options:CreateFrame("NPA_Options_NameText_Filter6",mainframe)

local checkboxdata={
	["NameText_Mark"]=Localization["ShowMark"],
	["NameText_MarkTarget"]=Localization["MarkTarget"],
	["NameText_MarkFriend"]=Localization["MarkFriend"],
	["NameText_MarkRaidMember"]=Localization["MarkRaidMember"],
	["NameText_MarkGuildMember"]=Localization["MarkGuildMember"],
	["NameText_MarkPartyMember"]=Localization["MarkPartyMember"],
	["NameText_MarkHideInInstance"]=Localization["MarkHideInInstance"],
	["NameText_MarkColorByType"]=Localization["MarkColorByType"],
	["NameText_MarkPartyAsRaid"]=Localization["MarkPartyAsRaid"],
	["NameText_MarkFocus"]=Localization["MarkFocus"],
	["NameText_MarkMouseover"]=Localization["MarkMouseover"],
}
NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe6,21,checkboxdata,17,Options,1,1)



local checkbox=NPA_Options:CreateCheckBox("NPA_Options_NameText_LimitLength",mainframe,21,Localization["LimitLength"],"NameText_LimitLength")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-240)
table_insert(Options,checkbox)

local slideredit=NPA_Options:CreateSliderEdit("NPA_Options_NameText_Length",mainframe,Localization["Length"],"NameText_Length",1,18,1,nil,nil,Tooltips["UnitData_UpdateInterval"])
slideredit:SetPoint("TOPLEFT",checkbox,"BOTTOMLEFT",6,-5)
table_insert(Options,slideredit)


local button1=NPA_Options:CreateButton("NPA_Options_NameText_Button1",mainframe,230,22,Localization["MainList"])
button1:SetPoint("TOPRIGHT",mainframe,"TOPRIGHT",-6,-6)
button1:SetScript("OnShow",function()
		listframe:Show()
		listframe3:Show()
		listframe4:Show()
		listframe5:Show()
		listframe6:Show()
		
		listframe:Hide()
		listframe3:Hide()
		listframe4:Hide()
		listframe5:Hide()
		listframe6:Hide()

	end)
button1:SetScript("OnClick",function()
		if(listframe:IsShown())then
			listframe:Hide()
		else
			listframe:Show()
		end
		listframe3:Hide()
		listframe4:Hide()
		listframe5:Hide()
		listframe6:Hide()
	end)
listframe:SetPoint("TOPLEFT",button1,"TOPRIGHT",6,0)


local button3=NPA_Options:CreateButton("NPA_Options_NameText_Button3",mainframe,230,22,Localization["ColorList"])
button3:SetPoint("TOPRIGHT",button1,"BOTTOMRIGHT",0,-6)
button3:SetScript("OnClick",function()
		if(listframe3:IsShown())then
			listframe3:Hide()
		else
			listframe3:Show()
		end
		listframe:Hide()
		listframe4:Hide()
		listframe5:Hide()
		listframe6:Hide()
	end)
listframe3:SetPoint("TOPLEFT",button3,"TOPRIGHT",6,0)

local button4=NPA_Options:CreateButton("NPA_Options_NameText_Button4",mainframe,230,22,Localization["FilterList"])
button4:SetPoint("TOPRIGHT",button3,"BOTTOMRIGHT",0,-6)
button4:SetScript("OnClick",function()
		if(listframe4:IsShown())then
			listframe4:Hide()
		else
			listframe4:Show()
		end
		listframe:Hide()
		listframe3:Hide()
		listframe5:Hide()
		listframe6:Hide()
	end)
listframe4:SetPoint("TOPLEFT",button4,"TOPRIGHT",6,0)

local button5=NPA_Options:CreateButton("NPA_Options_NameText_Button5",mainframe,230,22,Localization["PortraitList"])
button5:SetPoint("TOPRIGHT",button4,"BOTTOMRIGHT",0,-6)
button5:SetScript("OnClick",function()
		if(listframe5:IsShown())then
			listframe5:Hide()
		else
			listframe5:Show()
		end
		listframe:Hide()
		listframe3:Hide()
		listframe4:Hide()
		listframe6:Hide()
	end)
listframe5:SetPoint("TOPLEFT",button5,"TOPRIGHT",6,0)

local button6=NPA_Options:CreateButton("NPA_Options_NameText_Button6",mainframe,230,22,Localization["MarkList"])
button6:SetPoint("TOPRIGHT",button5,"BOTTOMRIGHT",0,-6)
button6:SetScript("OnClick",function()
		if(listframe6:IsShown())then
			listframe6:Hide()
		else
			listframe6:Show()
		end
		listframe:Hide()
		listframe3:Hide()
		listframe4:Hide()
		listframe5:Hide()
	end)
listframe6:SetPoint("TOPLEFT",button6,"TOPRIGHT",6,0)

end