﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

if(NPA_Core:CheckHook("TargetCount"))then

local Localization={}
local Tooltips={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs

if(locale=="zhTW")then
	Localization={
		["PageName"]="目標計數",
		["ShowNonHostile"]="顯示非敵對",
		["ShowHostile"]="顯示敵對",
		["OnlyPlayer"]="只計算玩家",
		["Text"]="文本",
		["ShowIcon"]="顯示圖標",
		["FriendlyMax"]="超過這個數量時顯示友方圖標",
		["HostileMax"]="超過這個數量時顯示敵方圖標",
		["HostileIcon"]="敵方圖標",
		["FriendlyIcon"]="友方圖標",
	}
	Tooltips={
		["TargetCount"]="顯示以單位為目標的友方/敵方數量",
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="目标计数",
		["ShowNonHostile"]="显示非敌对",
		["ShowHostile"]="显示敌对",
		["OnlyPlayer"]="只计算玩家",
		["Text"]="文本",
		["ShowIcon"]="显示图标",
		["FriendlyMax"]="超过这个数量时显示友方图标",
		["HostileMax"]="超过这个数量时显示敌方图标",
		["HostileIcon"]="敌方图标",
		["FriendlyIcon"]="友方图标",
	}
	Tooltips={
		["TargetCount"]="显示以单位为目标的友方/敌方数量",
	}

else
	Localization={
		["PageName"]="TargetCount",
		["ShowNonHostile"]="Show non-hostile",
		["ShowHostile"]="Show hostile",
		["OnlyPlayer"]="Count only player",
		["Text"]="Text",
		["ShowIcon"]="Show icon",
		["FriendlyMax"]="Show friendly icon when over this number",
		["HostileMax"]="Show hostile icon when over this number",
		["HostileIcon"]="HostileIcon",
		["FriendlyIcon"]="FriendlyIcon",
	}
	Tooltips={
		["TargetCount"]="Shows count of friendly/hostile who's targeting unit",
	}

end


local mainframe=NPA_Options:AddPage("NPA_Options_TargetCount",Localization["PageName"],"TargetCount",Tooltips["TargetCount"])

local Options=mainframe.Options


NPA_Options:CreateSliderEditButton(Localization["Text"],mainframe,"TargetCount_TextData",2,Options,4)
NPA_Options:CreateSliderEditButton(Localization["HostileIcon"],mainframe,"TargetCount_HostileIconData",3,Options,5)
NPA_Options:CreateSliderEditButton(Localization["FriendlyIcon"],mainframe,"TargetCount_FriendlyIconData",3,Options,6)

--

local sliderlist={
	["TargetCount_HostileMax"]={
		Name=Localization["HostileMax"],
		Min=0,
		Max=6,
		Step=1,
		Width=140,
		OffsetX=20,
		OffsetY=-5
	},
	["TargetCount_FriendlyMax"]={
		Name=Localization["FriendlyMax"],
		Min=0,
		Max=6,
		Step=1,
		Width=140,
		OffsetX=20,
		OffsetY=-55
	}
}


NPA_Options:BuildSliderList("NPA_Options_TargetCount",mainframe,sliderlist,Options)

-----------------
local listframe=NPA_Options:CreateFrame("NPA_Options_TargetCount_Filter",mainframe)
listframe:SetPoint("TOPRIGHT",-6,-6)
listframe:SetWidth(200)

local checkboxdata={
	["TargetCount_ShowHostile"]=Localization["ShowHostile"],
	["TargetCount_ShowNonHostile"]=Localization["ShowNonHostile"],
	["TargetCount_OnlyPlayer"]=Localization["OnlyPlayer"],
	["TargetCount_ShowIcon"]=Localization["ShowIcon"]

}

NPA_Options:BuildCheckBoxList("NPA_Options_ComboPoint",listframe,21,checkboxdata,18,Options,1)


end